
function setup() {
    let canvas = createCanvas(windowWidth, windowHeight * 0.6);
    pixelDensity(2);
    noLoop();

    canvas.parent('canvas');
  }
  
  function draw() {
    background('#f2f2f2');
  
    for (let i = 1; i < 50; i += 1) {
      push();
      translate(width / 2, height / 2);
      var s = random(0.3,random(0.3,random(0.3,random(0.3,4))));
      scale(s);
      var x = random(-width/2/s-50, width/2/s-50);
      var y = random(-height/2/s-50, height/2/s-50);
      gear(x, y);
      
      pop();
    }
  }
  
  
  function gear(x, y) {
    noStroke();
    
    var colorset = ['#00796B', '#67AB52', '#CDDC39',
                        '#D1D1D1', '#47453B'];
    var n = ceil(random(5, 11));
    var theta = 2*PI/n;
    var dang1 = 2*PI/50;
    var dang2 = 2*PI/25;
    var dia1 = 50;
    var dia2 = 40;
    var rot = random(0, 2*PI);
  
  
    fill(colorset[ceil(random(-1, 4))]);
  
    beginShape();
    for (let i = 0; i < n; i += 1) {
      vertex((x + dia2 * cos(theta * i - dang2 + rot)), y + dia2 * sin(theta * i - dang2 + rot));
      vertex(x + dia1 * cos(theta * i - dang1 + rot), y + dia1 * sin(theta * i - dang1 + rot));
      vertex(x + dia1 * cos(theta * i + dang1 + rot), y + dia1 * sin(theta * i + dang1 + rot));
      vertex(x + dia2 * cos(theta * i + dang2 + rot), y + dia2 * sin(theta * i + dang2 + rot));
    }
    endShape(CLOSE);
  
    fill('#f2f2f2');
    ellipse(x, y, 37.5, 37.5);
  
  }
  
  function mousePressed() {
    redraw();
  }